// -- Typography

.cui-h1 { @include cui-head(1); }
.cui-h2 { @include cui-head(2); }
.cui-h3 { @include cui-head(3); }
.cui-h4 { @include cui-head(4); }
.cui-h5 { @include cui-head(5); }
.cui-h6 { @include cui-head(6); }

.cui-text-xl { @include cui-text(xl); }
.cui-text-l { @include cui-text(l); }
.cui-text-m { @include cui-text(m); }
.cui-text-s { @include cui-text(s); }
.cui-text-xs { @include cui-text(xs); }

// select without increasing specificity
:where(.cui-typo) {
  @include cui-text(m);

  h1 { @include cui-head(1); }
  h2 { @include cui-head(2); }
  h3 { @include cui-head(3); }
  h4 { @include cui-head(4); }
  h5 { @include cui-head(5); }
  h6 { @include cui-head(6); }

  h1, h2, h3, h4, h5, h6 {
    margin-top: 0;
    margin-bottom: $cui-h-margin-bottom;
  }

  p {
    margin-top: 0;
    margin-bottom: $cui-p-margin-bottom;
  }

  hr {
    margin: 1rem 0;
    height: 1px; // stylelint-disable-line unit-allowed-list
    border: 0;
    background-color: $cui-default-border-color;
  }

  // ----- links
  /* stylelint-disable no-descending-specificity */

  //TODO: simplify
  a:where(:not(.cui-plain)):where(:not(.cui-menu-item)):where(:not(.cui-button)) {
    color: $cui-link-color;
    outline-color: transparent;
    text-decoration: none;
    transition: color $cui-hover-transition,
    outline-color $cui-focus-transition;

    &:hover {
      color: $cui-link-color-hover;
      text-decoration: underline;
    }
    &:active {
      color: $cui-link-color-active;
    }
    &:focus {
      /* stylelint-disable unit-allowed-list */
      outline: $cui-focus-color auto 2px;
      outline-offset: -2px;
      /* stylelint-enable unit-allowed-list */
    }
  }

  a[tabindex="-1"]:focus {
    outline: none;
  }

  /* stylelint-enable no-descending-specificity */
  // ----- emphasis

  b, strong, .cui-strong {
    font-weight: $cui-font-weight-strong;
  }

  mark, .cui-mark {
    padding: .125rem .25rem;
    background-color: $cui-mark-color;
  }

  small, .cui-small {
    font-size: $cui-font-size-small;
  }

  .cui-underline {
    text-decoration: underline;
  }

  .cui-line-through {
    text-decoration: line-through;
  }

  // --- kbd

  kbd {
    border-radius: 0.25rem;
    border: 2px solid $cui-n50;
    padding: 0.25rem 0.375rem;
    color: $cui-n200;
    font-size: 0.75rem;
    line-height: 0.75rem;
    display: inline-flex;
    font-weight: $cui-font-weight-strong;
    font-family: $cui-font-code;
    text-transform: uppercase;
    text-align: center;

    &.symbol {
      padding: 0.1875rem 0.375rem 0.3125rem;
      font-size: 0.875rem;
    }
  }

  // ----- lists

  ol, ul {
    padding-left: 2rem;
  }

  ol, ul, dl {
    margin-top: 0;
    margin-bottom: 1rem;
  }

  ol ol, ul ul, ol ul, ul ol {
    margin-bottom: 0;
  }

  dt {
    font-weight: $cui-font-weight-h;
  }

  dd {
    margin-bottom: .5rem;
    margin-left: 0;
  }

  ul.cui-plain,
  ol.cui-plain {
    @include cui-list-plain();
  }

  // ----- blockquotes & figures

  blockquote {
    margin: 0 0 $cui-p-margin-bottom;
    font-style: italic;
    @include cui-text(l);
    color: $cui-quote-color;

    > :last-child {
      margin-bottom: 0;
    }
  }

  figure {
    margin: 0 0 $cui-p-margin-bottom;

    figcaption {
      margin-top: -$cui-p-margin-bottom * 0.5;
      margin-bottom: 0;
      @include cui-text(s);
      color: $cui-quote-source-color;

      &::before {
        content: "\2014\00A0"; // em dash, nbsp
      }
    }
  }

  // ----- code

  code {
    font-family: $cui-font-code, $cui-font-code-fallback;
    font-size: .875em;
    color: $cui-code-color;
    word-wrap: break-word;
  }

  pre {
    border: 1px solid $cui-default-border-color;
    border-radius: cui-border-radius(m);
    margin-top: 0;
    margin-bottom: $cui-p-margin-bottom;
    background-color: $cui-code-block-background-color;
    padding: .5rem;
    display: block;
    overflow: auto;
    font-size: .875em;
    white-space: pre;

    code {
      font-size: inherit;
      color: $cui-code-block-color;
      word-wrap: normal;
    }
  }

  // ----- forms

  form {
    > :last-child {
      margin-bottom: 0;
    }
  }

  // ----- tables
  // @see https://getbootstrap.com/docs/5.1/content/tables/#how-nesting-works
  // stylelint-disable no-descending-specificity

  thead, tbody, tfoot, tr, th, td {
    border-color: inherit;
    border-style: solid;
    border-width: 0;
  }

  table {
    vertical-align: top;
    border-collapse: collapse;
    > thead { vertical-align: bottom; }
    > tbody { vertical-align: inherit; }
  }

  tbody.cui-collapse > tr {
    background-color: $cui-table-collapsable-background-color;
  }

  table:where(:not(.cui-plain)):where(:not(.myDpCalTable)) {
    width: 100%;
    border-color: $cui-default-border-color;
    text-align: left;
    margin-bottom: $cui-p-margin-bottom;

    thead { border-bottom-width: 2px; }
    tfoot { border-top-width: 2px; }

    tr, th, td {
      &.cui-selected {
        background-color: $cui-table-selected-background-color;
      }
    }

    th {
      @include cui-head(6);
      color: $cui-n200;
    }

    > :not(caption) > * > * {
      padding: 1rem;
      border-bottom-width: 1px;

      &.cui-sortable {
        padding-right: 2rem;
      }
    }

    > :last-child > :last-child > * {
      border-bottom-width: 0;
    }

    th, td {
      &.cui-shrink {
        width: 1px; // stylelint-disable-line unit-allowed-list
        white-space: nowrap;
      }
      &.cui-align-middle {
        padding-top: 0;
        padding-bottom: 0;
        vertical-align: middle;
      }
      &.cui-align-center {
        text-align: center;
      }
    }

    // ----- bordered

    &.cui-table-bordered > :not(caption) {
      > * { border-width: 1px 0; }
      > * > * { border-width: 0 1px; }
    }

    // ----- striped

    &.cui-table-striped > tbody > tr:not(.cui-selected):nth-of-type(odd) {
      background-color: $cui-table-striped-background-color;
    }

    // ----- hover

    &.cui-table-hover > tbody > tr:not(.cui-selected):hover {
      background-color: $cui-table-hover-background-color;
    }
  }

  // ----- Sticky table header / footer

  .cui-scrollable table.cui-table-sticky {
    position: relative;
    margin-bottom: 0;

    thead, tfoot {
      z-index: 3;
      position: sticky;
      background: $cui-n0;
      @include cui-elevation-transition();
    }

    thead {
      inset-block-start: 0;
      // fix weird sroll error where table can be seen behing thead
      box-shadow: 0 -1rem 0 1rem $cui-n0;
    }

    tfoot {
      inset-block-end: 0;
      // fix weird sroll error where table can be seen behing tfoot
      box-shadow: 0 1rem 0 1rem $cui-n0;
    }
  }

  .cui-scrollable-top table.cui-table-sticky thead {
    box-shadow: 0 -1rem 0 1rem $cui-n0,
                $cui-scrollable-table-shadow-top;
  }

  .cui-scrollable-bottom table.cui-table-sticky tfoot {
    box-shadow: 0 1rem 0 1rem $cui-n0,
                $cui-scrollable-table-shadow-bottom;
  }
}
